local Gnoll = _G.Gnoll
local GL = Gnoll.Locale
local GLW = Gnoll.WoWLocale

local function OnEnterButton(self,link)
		GameTooltip:SetOwner(self, "ANCHOR_NONE")
		GameTooltip:SetPoint("BOTTOM", self, "LEFT", 0, 5)
		if link ~= nil then
			GameTooltip:SetHyperlink(link)
		end
end

local function OnLeaveButton(self)
	GameTooltip:Hide()
end

function CreateItemButtons(Frame)
	ItemButtons = { { } }

	for i=1, 30 do
		if i <= 10 then
			abstand = i*40
			spalte = 55
		elseif i >= 11 and i <= 20 then 
			 abstand = (i-10) *40
			 spalte = 250+55
		elseif i >= 21 and i <= 30 then
			 abstand = (i-20) *40
			 spalte = 500+55
		end
			
		ItemButtons[i] = CreateFrame("Button", nil, Frame)
		button = ItemButtons[i]
		
		button:SetPoint("Topleft", Frame, 0+spalte-32, 0-abstand)
		button:SetWidth(232)
		button:SetHeight(32)
			
		local fo = button:CreateFontString()
			fo:SetFont("Fonts/FRIZQT__.TTF",10)
			fo:SetPoint("LEFT", button, "LEFT", 34,0)
			fo:SetText("test")
			button:SetFontString(fo)
		
		local ntex = button:CreateTexture()
		ntex:SetTexture("Interface/FrameGeneral/UI-Background-Marble")
		ntex:SetAlpha(0.8) 
		ntex:SetAllPoints()
		button:SetNormalTexture(ntex)
		--button:SetScript("OnEnter", OnEnterButton)
		button:SetScript("OnLeave", OnLeaveButton)
		button:Hide()
		
		
		button.icon = CreateFrame("Button", nil, button)
		icon = button.icon
		
		icon:SetPoint("Left", button, 0, 0)
		icon:SetWidth(32)
		icon:SetHeight(32)
		
		local itex = icon:CreateTexture()
		itex:SetTexture("Interface\ICONS\Ability_Creature_Cursed_03")
		itex:SetAllPoints()
		icon:SetNormalTexture(itex)
		icon:Show()

	end
end

function ClearItemButtons()
	for i=1,30 do
		ItemButtons[i]:Hide()
end

function ShowItemPage(self,button,arg1,arg2)
	itemTable = arg1
	local seite = -1
	if arg2 == nil then seite = 1 else seite = arg2 end
	local start = 30 * seite -29
	local ende = 30 * seite
	
	---Buttons mit Funktionen belegen
	ItemSeiteLinks:SetScript("OnMouseDown", function(self, button,arg1,arg2)
	ShowItemPage(self,button,itemTable, seite -1)
	end)
	ItemSeiteRechts:SetScript("OnMouseDown", function(self, button,arg1,arg2)
	ShowItemPage(self, button,itemTable, seite +1)
	end)
	
	if ende >= #itemTable then -- more Items ?
		ItemSeiteRechts:Hide()
	else
		ItemSeiteRechts:Show()
	end
	
	if seite > 1 then 
		ItemSeiteLinks:Show()
	else
		ItemSeiteLinks:Hide()
	end
	
	if #itemTable < ende then -- not enough items :(
		ende = #itemTable
	end
	
	local buttonid = 1
	for i = start, ende do
		ItemButtons[buttonid]:Show()
		
		local _, _, Farbe = string.find(itemTable[i][2],"|?c?f?f?(%x*)")
		local _, _, ItemName = string.find(itemTable[i][2],"|?h?%[?([^%[%]]*)%]")
		if strlen(ItemName) > 30 then ItemName = strsub(ItemName,0,30).."..." end --- irgendwie 3 punkte anfügen
		ItemButtons[buttonid]:SetText("|cff"..Farbe..ItemName)
		
		buttonid = buttonid +1
	end
	
	if buttonid < 30 then -- not enough items :(
		for i = buttonid, 30 do
			ItemButtons[buttonid]:Hide()
			buttonid = buttonid +1
		end
	end
end

function UpdateItems(itemTable)
	ItemSeiteRechts:Hide()
	ItemSeiteLinks:Hide()
	ClearItemButtons()
	
	local x = 0
	if #itemTable > 30 then   --- Es gibt mehr als 1 Seite
		x = 30
		ItemSeiteRechts:Show()
		ItemSeiteRechts:SetScript("OnMouseDown", function(self, button, arg1,arg2)
		ShowItemPage(self, button, itemTable,2) end)
	else
		x = #itemTable
	end

	for i = 1, x do
		if itemTable[i][2] == nil then
			ItemButtons[i]:SetText("Getting ItemInfo")
			ItemButtons[i]:SetScript("OnEnter", function(self,arg1)
			OnEnterButton(self)
			end)
		
		else
			--Inhalt
			local _, _, Farbe = string.find(itemTable[i][2],"|?c?f?f?(%x*)")
			local _, _, ItemName = string.find(itemTable[i][2],"|?h?%[?([^%[%]]*)%]")
			if strlen(ItemName) > 30 then ItemName = strsub(ItemName,0,30).."..." end --- irgendwie 3 punkte anfügen
			--ToolTip
			ItemButtons[i]:SetText("|cff"..Farbe..ItemName)
			ItemButtons[i]:SetScript("OnEnter", function(self,arg1)
			OnEnterButton(self,itemTable[i][2])
			end)
			--Buttongeklcike
			ItemButtons[i]:SetScript("OnClick", function(self, button)  -- reagiert nicht auf rightbutton ?? ka why
				if button == "LeftButton" then 
					if(IsShiftKeyDown()) then
						local e = DEFAULT_CHAT_FRAME.editBox
						ChatEdit_ActivateChat(e)
						local tmp = e:GetText()
						e:SetText(tmp .. itemTable[i][2])
					elseif(IsControlKeyDown()) then
						DressUpItemLink(itemTable[i][2])
					elseif(IsAltKeyDown()) then
						local kontinent = tonumber(DDME["selectedID"])
						local instanz  = tonumber(DDMI["selectedID"])
						local boss = tonumber(DDMB["selectedID"])
						if type(GnollCharDB["wunschliste"][itemTable[i][1]]) ~= "table" then
							GnollCharDB["wunschliste"][itemTable[i][1]] = { itemTable[i][2] ,kontinent,instanz,boss}
							print(itemTable[i][2].." "..GL["ItemWishlishADD"])
						else
							GnollCharDB["wunschliste"][itemTable[i][1]] = nil
							print(itemTable[i][2].." "..GL["ItemWishlishDEL"])
						end
					end
				end
			end)
			
			texture = GetItemIcon(itemTable[i][1])
			ItemButtons[i].icon:SetNormalTexture(texture)
		end
		if i <= 30 then
			ItemButtons[i]:Show()
		end
		
	end
	end
end

